package com.bipt.intelligentapplicationorchestrationservice.entity;

import java.util.Objects;

public class DeployRequest {
    private String modelId;
    private int requiredMemory;
    private DeployType deployType;
    private ModelInfo modelInfo;

    // 部署类型枚举
    public enum DeployType {
        NORMAL,
        GRAY
    }
    // 默认构造函数
    public DeployRequest() {
    }

    public DeployRequest(String modelId, int requiredMemory, DeployType deployType, ModelInfo modelInfo) {
        this.modelId = modelId;
        this.requiredMemory = requiredMemory;
        this.deployType = deployType;
        this.modelInfo = modelInfo;
    }

    // Getter & Setter 方法
    public String getModelId() {
        return modelId;
    }

    public void setModelId(String modelId) {
        this.modelId = modelId;
    }

    public int getRequiredMemory() {
        return requiredMemory;
    }

    public void setRequiredMemory(int requiredMemory) {
        this.requiredMemory = requiredMemory;
    }

    public DeployType getDeployType() {
        return deployType;
    }

    public void setDeployType(DeployType deployType) {
        this.deployType = deployType;
    }

    public ModelInfo getModelInfo() {
        return modelInfo;
    }

    public void setModelInfo(ModelInfo modelInfo) {
        this.modelInfo = modelInfo;
    }

    // Equals 和 HashCode 方法
    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        DeployRequest that = (DeployRequest) o;
        return requiredMemory == that.requiredMemory &&
                Objects.equals(modelId, that.modelId) &&
                deployType == that.deployType &&
                Objects.equals(modelInfo, that.modelInfo);
    }

    @Override
    public int hashCode() {
        return Objects.hash(modelId, requiredMemory, deployType, modelInfo);
    }

    // toString 方法
    @Override
    public String toString() {
        return "DeployRequest{" +
                "modelId='" + modelId + '\'' +
                ", requiredMemory=" + requiredMemory +
                ", deployType=" + deployType +
                ", modelInfo=" + modelInfo +
                '}';
    }
}
