package com.bipt.intelligentapplicationorchestrationservice.service;

import com.bipt.intelligentapplicationorchestrationservice.entity.GpuResourceRepository;
import com.bipt.intelligentapplicationorchestrationservice.entity.GpuResource;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

@Service
public class GpuResourceService {
    @Autowired
    private GpuResourceRepository repository;

    @Cacheable(value = "availableGpus")
    public List<GpuResource> getAvailableResources() {
// 获取所有未删除的资源
        return repository.findAll().stream()
                .filter(gpu -> gpu.getIsDeleted() == null || !gpu.getIsDeleted())
                .collect(Collectors.toList());    }

    public void markAsAllocated(Long gpuId, int allocatedMemory) {
        GpuResource gpu = repository.findById(gpuId);
        if (gpu != null) {
            // 更新已使用内存
            int currentMemory = gpu.getGPUMemorySize() != null ? gpu.getGPUMemorySize() : 0;
            gpu.setGPUMemorySize(currentMemory + allocatedMemory);
            repository.save(gpu);
        }
    }
}
